unit uErros;

interface

uses
  Classes, Math, Messages, Dialogs, SysUtils;

type
  TErros = class
  public
    class procedure AccessViolationSample;
    class procedure ListOutOfBoundsSample;
    class procedure StrConversionSample;
  end;

implementation

{ TErros }

class procedure TErros.AccessViolationSample;
var
  lista : TStringList;
begin
  lista.Add('Violao de Acesso');
end;

class procedure TErros.ListOutOfBoundsSample;
var
  lista : TStringList;
begin
  lista := TStringList.Create;
  try
    ShowMessage(lista[10]);
  finally
    lista.Destroy;
  end;
end;

class procedure TErros.StrConversionSample;
begin
  StrToInt('ABC');
end;

end.
