unit ufrmDatas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DateUtils, StdCtrls, Spin, ComCtrls, ExtCtrls;

type
  TfrmDatas = class(TForm)
    pgcDatas: TPageControl;
    tabFeriadosMoveis: TTabSheet;
    lblFeriadosMoveisAno: TLabel;
    spnFeriadosMoveisAno: TSpinEdit;
    lstFeriadosMoveis: TListBox;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    edtParTDateTime: TEdit;
    Label2: TLabel;
    edtParYear: TEdit;
    edtParMonth: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    edtParDay: TEdit;
    Label7: TLabel;
    Label6: TLabel;
    edtParMinute: TEdit;
    edtParSecond: TEdit;
    edtParHour: TEdit;
    Label3: TLabel;
    Label8: TLabel;
    edtParMilliSecond: TEdit;
    GroupBox2: TGroupBox;
    Label12: TLabel;
    edtParDayOfYear: TEdit;
    Label9: TLabel;
    edtParDayOfWeek: TEdit;
    Label10: TLabel;
    edtParWeekOfYear: TEdit;
    Label11: TLabel;
    edtParWeekOfMonth: TEdit;
    Panel2: TPanel;
    btnIsValidDateMonthWeek: TButton;
    Panel3: TPanel;
    Label13: TLabel;
    edtResposta: TEdit;
    PageControl1: TPageControl;
    tbsMiscelaneas: TTabSheet;
    btnIsInLeapYear: TButton;
    btnIsPM: TButton;
    btnIsAm: TButton;
    btnIsValidDate: TButton;
    btnIsValidTime: TButton;
    btnIsValidDateTime: TButton;
    btnIsValidDateDay: TButton;
    btnIsValidDateWeek: TButton;
    btnDaysInYear: TButton;
    btnDaysInAYear: TButton;
    btnDaysInAMonth: TButton;
    btnDaysInMonth: TButton;
    btnYesterday: TButton;
    btnToday: TButton;
    btnTomorrow: TButton;
    btnIsToday: TButton;
    btnIsSameDay: TButton;
    Label14: TLabel;
    edtParBasis: TEdit;
    tbsExtracao: TTabSheet;
    btnYearOf: TButton;
    btnMonthOf: TButton;
    btnWeekOf: TButton;
    btnDayOf: TButton;
    btnHourOf: TButton;
    btnMinuteOf: TButton;
    btnSecondOf: TButton;
    btnMilliSecondOf: TButton;
    tbsInicioFim: TTabSheet;
    btnStartOfTheYear: TButton;
    btnEndOfTheYear: TButton;
    btnStartOfAYear: TButton;
    btnEndOfAYear: TButton;
    btnStartOfTheMonth: TButton;
    btnStartOfAMonth: TButton;
    btnEndOfAMonth: TButton;
    btnEndOfTheMonth: TButton;
    btnStartOfTheWeek: TButton;
    btnStartOfAWeek: TButton;
    btnEndOfAWeek: TButton;
    btnEndOfTheWeek: TButton;
    btnStartOfTheDay: TButton;
    btnStartOfADay: TButton;
    btnEndOfADay: TButton;
    btnEndOfTheDay: TButton;
    btnStartOfADay2: TButton;
    btnEndOfADay2: TButton;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    tabIstoDisto: TTabSheet;
    pgcIstoDisto: TPageControl;
    tbsIstoDistoMes: TTabSheet;
    tbsIstoDistoSemana: TTabSheet;
    tbsIstoDistoDia: TTabSheet;
    tbsIstoDistoHora: TTabSheet;
    tbsIstoDistoMinuto: TTabSheet;
    btnMonthOfTheYear: TButton;
    btnWeekOfTheYear: TButton;
    btnWeekOfTheMonth: TButton;
    btnDayOfTheYear: TButton;
    btnDayOfTheMonth: TButton;
    btnDayOfTheWeek: TButton;
    btnHourOfTheYear: TButton;
    btnHourOfTheMonth: TButton;
    btnHourOfTheWeek: TButton;
    btnHourOfTheDay: TButton;
    tbsIstoDistoSegundo: TTabSheet;
    btnMinuteOfTheYear: TButton;
    btnMinuteOfTheMonth: TButton;
    btnMinuteOfTheWeek: TButton;
    btnMinuteOfTheDay: TButton;
    btnMinuteOfTheHour: TButton;
    btnSecondOfTheYear: TButton;
    btnSecondOfTheMonth: TButton;
    btnSecondOfTheWeek: TButton;
    btnSecondOfTheDay: TButton;
    btnSecondOfTheHour: TButton;
    btnSecondOfTheMinute: TButton;
    tbsIstoDistoMilissegundos: TTabSheet;
    btnMilliSecondOfTheYear: TButton;
    btnMilliSecondOfTheMonth: TButton;
    btnMilliSecondOfTheWeek: TButton;
    btnMilliSecondOfTheDay: TButton;
    btnMilliSecondOfTheHour: TButton;
    btnMilliSecondOfTheMinute: TButton;
    btnMilliSecondOfTheSecond: TButton;
    TabSheet2: TTabSheet;
    btnWithinPastSeconds: TButton;
    btnWithinPastMinutes: TButton;
    btnWithinPastHours: TButton;
    btnWithinPastDays: TButton;
    btnWithinPastWeeks: TButton;
    btnWithinPastMonths: TButton;
    btnWithinPastYears: TButton;
    btnWithinPastMilliSeconds: TButton;
    function Pascoa(Ano: Word): TDate;
    procedure spnFeriadosMoveisAnoChange(Sender: TObject);
    procedure btnIsInLeapYearClick(Sender: TObject);
    procedure btnIsPMClick(Sender: TObject);
    procedure btnIsAmClick(Sender: TObject);
    procedure PreparaParametros(Sender: TObject);
    procedure btnIsValidDateClick(Sender: TObject);
    procedure btnIsValidTimeClick(Sender: TObject);
    procedure btnIsValidDateTimeClick(Sender: TObject);
    procedure btnIsValidDateDayClick(Sender: TObject);
    procedure BlinkParams(caption : string);
    procedure BlinkTxt(controle : TEdit);
    procedure btnIsValidDateWeekClick(Sender: TObject);
    procedure btnIsValidDateMonthWeekClick(Sender: TObject);
    procedure MostraResposta(valor : variant);
    procedure btnDaysInYearClick(Sender: TObject);
    procedure btnDaysInAYearClick(Sender: TObject);
    procedure btnDaysInMonthClick(Sender: TObject);
    procedure btnIsSameDayClick(Sender: TObject);
    procedure btnDaysInAMonthClick(Sender: TObject);
    procedure btnIsTodayClick(Sender: TObject);
    procedure btnTomorrowClick(Sender: TObject);
    procedure btnYesterdayClick(Sender: TObject);
    procedure btnTodayClick(Sender: TObject);
    procedure btnYearOfClick(Sender: TObject);
    procedure btnMonthOfClick(Sender: TObject);
    procedure btnWeekOfClick(Sender: TObject);
    procedure btnDayOfClick(Sender: TObject);
    procedure btnHourOfClick(Sender: TObject);
    procedure btnMinuteOfClick(Sender: TObject);
    procedure btnSecondOfClick(Sender: TObject);
    procedure btnMilliSecondOfClick(Sender: TObject);
    procedure btnStartOfTheYearClick(Sender: TObject);
    procedure btnEndOfTheYearClick(Sender: TObject);
    procedure btnStartOfAYearClick(Sender: TObject);
    procedure btnEndOfAYearClick(Sender: TObject);
    procedure btnStartOfTheMonthClick(Sender: TObject);
    procedure btnEndOfTheMonthClick(Sender: TObject);
    procedure btnStartOfAMonthClick(Sender: TObject);
    procedure btnEndOfAMonthClick(Sender: TObject);
    procedure btnStartOfAWeekClick(Sender: TObject);
    procedure btnEndOfAWeekClick(Sender: TObject);
    procedure btnStartOfTheWeekClick(Sender: TObject);
    procedure btnEndOfTheWeekClick(Sender: TObject);
    procedure btnStartOfTheDayClick(Sender: TObject);
    procedure btnEndOfTheDayClick(Sender: TObject);
    procedure btnStartOfADayClick(Sender: TObject);
    procedure btnEndOfADayClick(Sender: TObject);
    procedure btnStartOfADay2Click(Sender: TObject);
    procedure btnEndOfADay2Click(Sender: TObject);
    procedure btnMonthOfTheYearClick(Sender: TObject);
    procedure btnWeekOfTheYearClick(Sender: TObject);
    procedure btnDayOfTheYearClick(Sender: TObject);
    procedure btnHourOfTheYearClick(Sender: TObject);
    procedure btnMinuteOfTheYearClick(Sender: TObject);
    procedure btnSecondOfTheYearClick(Sender: TObject);
    procedure btnMilliSecondOfTheYearClick(Sender: TObject);
    procedure btnWeekOfTheMonthClick(Sender: TObject);
    procedure btnDayOfTheMonthClick(Sender: TObject);
    procedure btnHourOfTheMonthClick(Sender: TObject);
    procedure btnMinuteOfTheMonthClick(Sender: TObject);
    procedure btnSecondOfTheMonthClick(Sender: TObject);
    procedure btnMilliSecondOfTheMonthClick(Sender: TObject);
    procedure btnDayOfTheWeekClick(Sender: TObject);
    procedure btnHourOfTheWeekClick(Sender: TObject);
    procedure btnMinuteOfTheWeekClick(Sender: TObject);
    procedure btnSecondOfTheWeekClick(Sender: TObject);
    procedure btnMilliSecondOfTheWeekClick(Sender: TObject);
    procedure btnHourOfTheDayClick(Sender: TObject);
    procedure btnMinuteOfTheDayClick(Sender: TObject);
    procedure btnSecondOfTheDayClick(Sender: TObject);
    procedure btnMilliSecondOfTheDayClick(Sender: TObject);
    procedure btnMinuteOfTheHourClick(Sender: TObject);
    procedure btnSecondOfTheHourClick(Sender: TObject);
    procedure btnMilliSecondOfTheHourClick(Sender: TObject);
    procedure btnSecondOfTheMinuteClick(Sender: TObject);
    procedure btnMilliSecondOfTheMinuteClick(Sender: TObject);
    procedure btnMilliSecondOfTheSecondClick(Sender: TObject);
    procedure tbsIstoDistoMilissegundosContextPopup(Sender: TObject;
      MousePos: TPoint; var Handled: Boolean);
    procedure btnWithinPastYearsClick(Sender: TObject);
    procedure btnWithinPastMonthsClick(Sender: TObject);
    procedure btnWithinPastWeeksClick(Sender: TObject);
    procedure btnWithinPastDaysClick(Sender: TObject);
    procedure btnWithinPastHoursClick(Sender: TObject);
    procedure btnWithinPastMinutesClick(Sender: TObject);
    procedure btnWithinPastSecondsClick(Sender: TObject);
    procedure btnWithinPastMilliSecondsClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDatas: TfrmDatas;
  Data1: variant;
  Data2: variant;
  Ano: variant;
  Mes: variant;
  Dia: variant;
  Hora : variant;
  Minuto : variant;
  Segundo : variant;
  Milissegundos : variant;
  DayOfYear : variant;
  DayOfWeek : variant;
  WeekOfYear : variant;
  WeekOfMonth : variant;
  Basis : variant;

implementation

{$R *.dfm}
{ TfrmDatas }

// Miscelneas

procedure TfrmDatas.BlinkParams(caption: string);
begin
   if (Pos('AValue,', caption) > 0) or (Pos('AValue:', caption) > 0) then BlinkTxt(edtParTDateTime);
   if (Pos('ANow,', caption) > 0) or (Pos('ANow:', caption) > 0) then BlinkTxt(edtParTDateTime);
   if (Pos('AYear,', caption) > 0) or (Pos('AYear:', caption) > 0) then BlinkTxt(edtParYear);
   if (Pos('AYears,', caption) > 0) or (Pos('AYears:', caption) > 0) then BlinkTxt(edtParYear);
   if (Pos('AMonth,', caption) > 0) or (Pos('AMonth:', caption) > 0) then BlinkTxt(edtParMonth);
   if (Pos('AMonths,', caption) > 0) or (Pos('AMonths:', caption) > 0) then BlinkTxt(edtParMonth);
   if (Pos('ADay,', caption) > 0) or (Pos('ADay:', caption) > 0) then BlinkTxt(edtParDay);
   if (Pos('ADays,', caption) > 0) or (Pos('ADays:', caption) > 0) then BlinkTxt(edtParDay);
   if (Pos('AHour,', caption) > 0) or (Pos('AHour:', caption) > 0) then BlinkTxt(edtParHour);
   if (Pos('AHours,', caption) > 0) or (Pos('AHours:', caption) > 0) then BlinkTxt(edtParHour);
   if (Pos('AMinute,', caption) > 0) or (Pos('AMinute:', caption) > 0) then BlinkTxt(edtParMinute);
   if (Pos('AMinutes,', caption) > 0) or (Pos('AMinutes:', caption) > 0) then BlinkTxt(edtParMinute);
   if (Pos('ASecond,', caption) > 0) or (Pos('ASecond:', caption) > 0) then BlinkTxt(edtParSecond);
   if (Pos('ASeconds,', caption) > 0) or (Pos('ASeconds:', caption) > 0) then BlinkTxt(edtParSecond);
   if (Pos('AMilliSecond,', caption) > 0) or (Pos('AMilliSecond:', caption) > 0)  then BlinkTxt(edtParMilliSecond);
   if (Pos('AMilliSeconds,', caption) > 0) or (Pos('AMilliSeconds:', caption) > 0)  then BlinkTxt(edtParMilliSecond);
   if (Pos('ADayOfYear,', caption) > 0) or (Pos('ADayOfYear:', caption) > 0)  then BlinkTxt(edtParDayOfYear);
   if (Pos('ADayOfWeek,', caption) > 0) or (Pos('ADayOfWeek:', caption) > 0)  then BlinkTxt(edtParDayOfWeek);
   if (Pos('AWeekOfYear,', caption) > 0) or (Pos('AWeekOfYear:', caption) > 0)  then BlinkTxt(edtParWeekOfYear);
   if (Pos('AWeekOfMonth,', caption) > 0) or (Pos('AWeekOfMonth:', caption) > 0)  then BlinkTxt(edtParWeekOfMonth);
   if (Pos('ABasis,', caption) > 0) or (Pos('ABasis:', caption) > 0)  then BlinkTxt(edtParBasis);
   if (Pos('AThen,', caption) > 0) or (Pos('AThen:', caption) > 0) then BlinkTxt(edtParBasis);
end;

procedure TfrmDatas.PreparaParametros(Sender: TObject);
begin
  edtResposta.Text := '';
  BlinkParams((Sender as TButton).Caption);
  Data1 := edtParTDateTime.Text;
  Ano := edtParYear.Text;
  Mes := edtParMonth.Text;
  Dia := edtParDay.Text;
  Hora := edtParHour.Text;
  Minuto := edtParMinute.Text;
  Segundo := edtParSecond.Text;
  Milissegundos := edtParMilliSecond.Text;
  DayOfYear := edtParDayOfYear.Text;
  DayOfWeek := edtParDayOfWeek.Text;
  WeekOfYear := edtParWeekOfYear.Text;
  WeekOfMonth := edtParWeekOfMonth.Text;
  Basis := edtParBasis.Text;
end;

procedure TfrmDatas.BlinkTxt(controle: TEdit);
var
   CorAnterior : TColor;
begin
   CorAnterior := controle.Color;
   controle.Color := clInfoBk;
   Refresh;
   Sleep(1000);
   controle.Color := CorAnterior;
end;


procedure TfrmDatas.btnDaysInAMonthClick(Sender: TObject);
begin
  PreparaParametros(Sender);
  MostraResposta('Dias no ms: ' + IntToStr(DaysInAMonth(ano, mes)));
end;

procedure TfrmDatas.btnDaysInAYearClick(Sender: TObject);
begin
  PreparaParametros(Sender);
  MostraResposta('Dias no ano: ' +IntToStr(DaysInAYear(Ano)));
end;

procedure TfrmDatas.btnDaysInMonthClick(Sender: TObject);
begin
  PreparaParametros(Sender);
  MostraResposta('Dias no ms: ' +IntToStr(DaysInMonth(strtodatetime(data1))));
end;

procedure TfrmDatas.btnDaysInYearClick(Sender: TObject);
begin
  PreparaParametros(Sender);
  MostraResposta('Dias no ano: ' +IntToStr(DaysInYear(StrToDateTime(Data1))));
end;

procedure TfrmDatas.btnIsAmClick(Sender: TObject);
begin
  PreparaParametros(Sender);
  if IsAM(StrToDateTime(Data1)) then
     MostraResposta('Antes de meio dia.')
  else
     MostraResposta('Meio dia e aps.');
end;

procedure TfrmDatas.btnIsInLeapYearClick(Sender: TObject);
begin
  PreparaParametros(Sender);
  if IsInLeapYear(StrToDateTime(Data1)) then
    MostraResposta('Ano bissexto.')
  else
    MostraResposta('Ano no bissexto.');
end;

procedure TfrmDatas.btnIsPMClick(Sender: TObject);
begin
  PreparaParametros(Sender);
  if IsPM(StrToDateTime(Data1)) then
    MostraResposta('Meio dia e aps.')
  else
    MostraResposta('Antes de meio dia.');
end;

procedure TfrmDatas.btnIsSameDayClick(Sender: TObject);
begin
  PreparaParametros(Sender);
  if IsSameDay(strtodatetime(data1), strtodatetime(basis)) then
    MostraResposta(' o mesmo dia.')
  else
    MostraResposta('No  o mesmo dia.');
end;

procedure TfrmDatas.btnIsTodayClick(Sender: TObject);
begin
  PreparaParametros(Sender);
  if IsToday(strtodatetime(data1)) then
    MostraResposta('Data corresponde a hoje.')
  else
    MostraResposta('Data no corresponde a hoje.');
end;

procedure TfrmDatas.btnIsValidDateClick(Sender: TObject);
begin
  PreparaParametros(Sender);
  if IsValidDate(ano, mes, dia) then
    MostraResposta('Data vlida.')
  else
    MostraResposta('Data invlida.');
end;

procedure TfrmDatas.btnIsValidDateDayClick(Sender: TObject);
begin
  PreparaParametros(Sender);
  if IsValidDateDay(ano, DayOfYear) then
    MostraResposta('Dia vlido para o ano indicado.')
  else
    MostraResposta('Dia invlido para o ano indicado.');
end;

procedure TfrmDatas.btnIsValidDateMonthWeekClick(Sender: TObject);
begin
  PreparaParametros(Sender);
  if IsValidDateMonthWeek(ano, mes, WeekOfMonth, DayOfWeek) then
    MostraResposta('Dia existe na semana e mes indicado.')
  else
    MostraResposta('Dia/Semana invlido(s) mes e ano indicado.');
end;

procedure TfrmDatas.btnIsValidTimeClick(Sender: TObject);
begin
  PreparaParametros(Sender);
  if IsValidTime(hora, minuto, Segundo, Milissegundos) then
    MostraResposta('Horrio vlido.')
  else
    MostraResposta('Horrio invlido.');
end;


procedure TfrmDatas.btnTodayClick(Sender: TObject);
begin
    MostraResposta('Hoje  dia ' + DateTimeToStr(Today()));
end;

procedure TfrmDatas.btnTomorrowClick(Sender: TObject);
begin
    MostraResposta('Amanh ser dia ' + DateTimeToStr(Tomorrow()));
end;

procedure TfrmDatas.btnYesterdayClick(Sender: TObject);
begin
    MostraResposta('Ontem foi o dia ' + DateTimeToStr(Yesterday()));
end;

procedure TfrmDatas.MostraResposta(valor: variant);
begin
   edtResposta.Text := valor;
   BlinkTxt(edtresposta);
end;

procedure TfrmDatas.btnIsValidDateTimeClick(Sender: TObject);
begin
  PreparaParametros(Sender);
  if IsValidDateTime(ano, mes, dia, hora, minuto, Segundo, Milissegundos) then
    MostraResposta('DateTime vlido.')
  else
    MostraResposta('DateTime invlido.');
end;

procedure TfrmDatas.btnIsValidDateWeekClick(Sender: TObject);
begin
  PreparaParametros(Sender);
  if IsValidDateWeek(ano, WeekOfYear, DayOfWeek) then
    MostraResposta('Este ano possui este dia para a semana indicada.')
  else
    MostraResposta('Este ano no possui este dia para a semana indicada.');
end;

{Feriados mveis}

function TfrmDatas.Pascoa(Ano: Word): TDate;
const
  X = 24;
  Y = 5;
var
  fatorA: Word;
  fatorB: Word;
  fatorC: Word;
  fatorD: Word;
  fatorE: Word;
  Dia: variant;
  Mes: variant;
begin
  fatorA := (Ano mod 19);
  fatorB := (Ano mod 4);
  fatorC := (Ano mod 7);
  fatorD := 19 * fatorA + X;
  fatorD := (fatorD mod 30);
  fatorE := 2 * fatorB + 4 * fatorC + 6 * fatorD + Y;
  fatorE := (fatorE mod 7);
  if fatorD + fatorE > 9 then
  begin
    Dia := (fatorD + fatorE - 9);
    Mes := 4;
  end
  else
  begin
    Dia := (fatorD + fatorE + 22);
    Mes := 3;
  end;
  if (Mes = 4) and (Dia = 26) then
    Dia := Dia - 7;
  if (Mes = 4) and (Dia = 25) and (fatorD = 28) and (fatorA > 10) then
    Dia := 18;
  result := EncodeDate(Ano, Mes, Dia);
end;

procedure TfrmDatas.spnFeriadosMoveisAnoChange(Sender: TObject);
var
  dPascoa: TDate;
  dCorpusCristi: TDate;
  dCarnaval: TDate;
  dPaixao: TDate;
begin
  dPascoa := Pascoa(spnFeriadosMoveisAno.value);
  dCarnaval := IncDay(dPascoa, -47);
  dPaixao := IncDay(dPascoa, -2);
  dCorpusCristi := IncDay(dPascoa, 60);
  lstFeriadosMoveis.Clear;
  lstFeriadosMoveis.Items.Add(IntToStr(DayOf(dCarnaval)) + ' de ' +
    FormatDateTime('mmmm', dCarnaval) + ' - Carnaval');
  lstFeriadosMoveis.Items.Add(IntToStr(DayOf(dPaixao)) + ' de ' +
    FormatDateTime('mmmm', dPaixao) + ' - Paixo de Cristo');
  lstFeriadosMoveis.Items.Add(IntToStr(DayOf(dPascoa)) + ' de ' +
    FormatDateTime('mmmm', dPascoa) + ' - Pscoa');
  lstFeriadosMoveis.Items.Add(IntToStr(DayOf(dCorpusCristi)) + ' de ' +
    FormatDateTime('mmmm', dCorpusCristi) + ' - Corpus Cristi');
end;

procedure TfrmDatas.tbsIstoDistoMilissegundosContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin

end;

{Extrao}

procedure TfrmDatas.btnYearOfClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Ano: ' + Inttostr(YearOf(strtodatetime(data1))));
end;

procedure TfrmDatas.btnMonthOfClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Ms: ' + Inttostr(MonthOf(strtodatetime(data1))));
end;


procedure TfrmDatas.btnWeekOfClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Semana: ' + Inttostr(WeekOf(strtodatetime(data1))));
end;

procedure TfrmDatas.btnDayOfClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Dia: ' + Inttostr(DayOf(strtodatetime(data1))));
end;


procedure TfrmDatas.btnHourOfClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Hora: ' + Inttostr(HourOf(strtodatetime(data1))));
end;

procedure TfrmDatas.btnMinuteOfClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Minuto: ' + Inttostr(MinuteOf(strtodatetime(data1))));
end;

procedure TfrmDatas.btnSecondOfClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Segundo: ' + Inttostr(SecondOf(strtodatetime(data1))));
end;

procedure TfrmDatas.btnMilliSecondOfClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Milissegundos: ' + Inttostr(MilliSecondOf(strtodatetime(data1))));
end;

{Incio e Fim}


procedure TfrmDatas.btnStartOfADay2Click(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Incio do dia: ' + datetimetostr(StartOfADay(ano, dayofyear)));
end;

procedure TfrmDatas.btnStartOfADayClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Incio do dia: ' + datetimetostr(StartOfADay(ano, mes, dia)));
end;

procedure TfrmDatas.btnStartOfAMonthClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Incio do ms: ' + datetimetostr(StartOfAMonth(strtoint(ano), strtoint(mes))));
end;

procedure TfrmDatas.btnStartOfAWeekClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Incio da semana: ' + datetimetostr(StartOfAWeek(ano, WeekOfYear)));
end;

procedure TfrmDatas.btnStartOfAYearClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Incio do ano: ' + datetimetostr(StartOfAYear(strtoint(ano))));
end;

procedure TfrmDatas.btnStartOfTheDayClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Incio do dia: ' + datetimetostr(StartOfTheDay(strtodatetime(data1))));
end;

procedure TfrmDatas.btnStartOfTheMonthClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Incio do ms: ' + datetimetostr(StartOfTheMonth(strtodatetime(data1))));
end;

procedure TfrmDatas.btnStartOfTheWeekClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Inicio da semana: ' + datetimetostr(StartOfTheWeek(strtodatetime(data1))));
end;

procedure TfrmDatas.btnStartOfTheYearClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Incio do ano: ' + datetimetostr(StartOfTheYear(strtodatetime(data1))));
end;

procedure TfrmDatas.btnEndOfADay2Click(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Final do dia: ' + datetimetostr(EndOfADay(ano, dayofyear)));
end;

procedure TfrmDatas.btnEndOfADayClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Final do dia: ' + datetimetostr(EndOfADay(ano, mes, dia)));
end;

procedure TfrmDatas.btnEndOfAMonthClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Fim do ms: ' + datetimetostr(EndOfAMonth(strtoint(ano), strtoint(mes))));
end;

procedure TfrmDatas.btnEndOfAWeekClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Final da semana: ' + datetimetostr(EndOfAWeek(ano, WeekOfYear)));
end;

procedure TfrmDatas.btnEndOfAYearClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Fim do ano: ' + datetimetostr(EndOfAYear(strtoint(ano))));
end;

procedure TfrmDatas.btnEndOfTheDayClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Fim do dia: ' + datetimetostr(EndOfTheDay(strtodatetime(data1))));
end;

procedure TfrmDatas.btnEndOfTheMonthClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Fim do ms: ' + datetimetostr(EndOfTheMonth(strtodatetime(data1))));
end;

procedure TfrmDatas.btnEndOfTheWeekClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Final da semana: ' + datetimetostr(EndOfTheWeek(strtodatetime(data1))));
end;

procedure TfrmDatas.btnEndOfTheYearClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Fim do ano: ' + datetimetostr(EndOfTheYear(strtodatetime(data1))));
end;

{Isto Disto}

procedure TfrmDatas.btnMonthOfTheYearClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Mes do ano: ' +  inttostr(MonthOfTheYear(strtodatetime(data1))));
end;

procedure TfrmDatas.btnWeekOfTheMonthClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Semana do ms: ' +  inttostr(WeekOfTheMonth(strtodatetime(data1))));
end;

procedure TfrmDatas.btnWeekOfTheYearClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Semana do ano: ' +  inttostr(WeekOfTheYear(strtodatetime(data1))));
end;

procedure TfrmDatas.btnWithinPastDaysClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta( WithinPastDays(strtodatetime(data1), strtodatetime(basis), Dia));
end;

procedure TfrmDatas.btnWithinPastHoursClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta( WithinPastHours(strtodatetime(data1), strtodatetime(basis), Hora));
end;

procedure TfrmDatas.btnWithinPastMilliSecondsClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta( WithinPastMilliSeconds(strtodatetime(data1), strtodatetime(basis), Milissegundos));
end;

procedure TfrmDatas.btnWithinPastMinutesClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta( WithinPastMinutes(strtodatetime(data1), strtodatetime(basis), minuto));
end;

procedure TfrmDatas.btnWithinPastMonthsClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta( WithinPastMonths(strtodatetime(data1), strtodatetime(basis), mes));
end;

procedure TfrmDatas.btnWithinPastSecondsClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta( WithinPastSeconds(strtodatetime(data1), strtodatetime(basis), Segundo));
end;

procedure TfrmDatas.btnWithinPastWeeksClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta( WithinPastWeeks(strtodatetime(data1), strtodatetime(basis), WeekOfYear));
end;

procedure TfrmDatas.btnWithinPastYearsClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta( WithinPastYears(strtodatetime(data1), strtodatetime(basis), ano));
end;

procedure TfrmDatas.btnDayOfTheMonthClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Dia do ms: ' +  inttostr(DayOfTheMonth(strtodatetime(data1))));
end;

procedure TfrmDatas.btnDayOfTheWeekClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Dia da semana: ' +  inttostr(DayOfTheWeek(strtodatetime(data1))));
end;

procedure TfrmDatas.btnDayOfTheYearClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Dia do ano: ' +  inttostr(DayOfTheYear(strtodatetime(data1))));
end;

procedure TfrmDatas.btnHourOfTheDayClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Hora do dia: ' +  inttostr(HourOfTheDay(strtodatetime(data1))));
end;

procedure TfrmDatas.btnHourOfTheMonthClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Hora do ms: ' +  inttostr(HourOfTheMonth(strtodatetime(data1))));
end;

procedure TfrmDatas.btnHourOfTheWeekClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Hora da semana: ' +  inttostr(HourOfTheWeek(strtodatetime(data1))));
end;

procedure TfrmDatas.btnHourOfTheYearClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Hora do ano: ' +  inttostr(HourOfTheYear(strtodatetime(data1))));
end;

procedure TfrmDatas.btnMinuteOfTheDayClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Minuto do dia: ' +  floattostr(MinuteOfTheDay(strtodatetime(data1))));
end;

procedure TfrmDatas.btnMinuteOfTheHourClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Minuto da hora: ' +  floattostr(MinuteOfTheHour(strtodatetime(data1))));
end;

procedure TfrmDatas.btnMinuteOfTheMonthClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Minuto do ms: ' +  floattostr(MinuteOfTheMonth(strtodatetime(data1))));
end;

procedure TfrmDatas.btnMinuteOfTheWeekClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Minuto da semana: ' +  inttostr(MinuteOfTheWeek(strtodatetime(data1))));
end;

procedure TfrmDatas.btnMinuteOfTheYearClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Minuto do ano: ' +  floattostr(MinuteOfTheYear(strtodatetime(data1))));
end;

procedure TfrmDatas.btnSecondOfTheDayClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Segundo do dia: ' +  floattostr(SecondOfTheDay(strtodatetime(data1))));
end;

procedure TfrmDatas.btnSecondOfTheHourClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Segundos da hora: ' +  floattostr(SecondOfTheHour(strtodatetime(data1))));
end;

procedure TfrmDatas.btnSecondOfTheMinuteClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Segundos do minuto: ' +  floattostr(SecondOfTheMinute(strtodatetime(data1))));
end;

procedure TfrmDatas.btnSecondOfTheMonthClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Segundo do ms: ' +  floattostr(SecondOfTheMonth(strtodatetime(data1))));
end;

procedure TfrmDatas.btnSecondOfTheWeekClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Segundo da semana: ' +  floattostr(SecondOfTheWeek(strtodatetime(data1))));
end;

procedure TfrmDatas.btnSecondOfTheYearClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Segundo do ano: ' +  floattostr(SecondOfTheYear(strtodatetime(data1))));
end;

procedure TfrmDatas.btnMilliSecondOfTheDayClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Milissegundo do dia: ' +  floattostr(MilliSecondOfTheDay(strtodatetime(data1))));
end;

procedure TfrmDatas.btnMilliSecondOfTheHourClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Milissegundos da hora: ' +  floattostr(MilliSecondOfTheHour(strtodatetime(data1))));
end;

procedure TfrmDatas.btnMilliSecondOfTheMinuteClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Milissegundo do minuto: ' +  floattostr(MilliSecondOfTheMinute(strtodatetime(data1))));
end;

procedure TfrmDatas.btnMilliSecondOfTheMonthClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Milissegundo do ms: ' +  floattostr(MilliSecondOfTheMonth(strtodatetime(data1))));
end;

procedure TfrmDatas.btnMilliSecondOfTheSecondClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Milissegundo do minuto: ' +  floattostr(MilliSecondOfTheSecond(strtodatetime(data1))));
end;

procedure TfrmDatas.btnMilliSecondOfTheWeekClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Milissegundo da semana: ' +  floattostr(MilliSecondOfTheWeek(strtodatetime(data1))));
end;

procedure TfrmDatas.btnMilliSecondOfTheYearClick(Sender: TObject);
begin
   PreparaParametros(Sender);
   MostraResposta('Milissegundo do ano: ' +  floattostr(MilliSecondOfTheYear(strtodatetime(data1))));
end;


end.
